; CODE TEST - STAN OCKERS.  in 'First Book of KIM'.
; Transcribed and small corrections by Jeff Tranter.
; Modified to use PB7 and 'B' timer on 2nd 6532 RIOT
; by Dave Hassler, '23.

        PADD    = $1741
        PBD     = $1742
        PBDD    = $1743
        INIT1   = $1E8E
	

      * = $0200

        LDX     #$0C            ; ... INITIALIZATION ...
INIT:   LDA     VALUES,X        ; .. 12 VALUES ARE LOADED
        STA     $E2,X           ; FROM 00E2 ON UP ..
        DEX			; (rather, $ED down...dhh)
        BPL     INIT
GRUP:   LDX     #$04            ; (SPACE LENGTH)
        JSR     SPACE           ; SPACE FOR ANOTHER GROUP
        LDA     #$06            ; GROUP SIZE, 5 CHAR.
        STA     $E0
CHAR:   DEC     $E0             ; NEXT CHAR. IN GROUP
        BEQ     GRUP            ; FINISHED, GET NEW GROUP
        LDX     #$03            ; (SPACE LENGTH)
        JSR     SPACE           ; SPACE BETWEEN CHAR.
NUMB:   JSR     RAND            ; GET A RANDOM #
        AND     #$3F            ; MAKE SURE POSITIVE
        CMP     #$28            ; LESS THAN 41 (DECIMAL)?
        BPL     NUMB            ; NO, GET ANOTHER
        TAX                     ; USE AS INDEX
        LDA     CONVRS,X        ; GET DISPLAY CONVERSION
        LDY     $E2             ; CHAR. INDEX IN Y
        STA     STORE,Y         ; STORE CONVERSION
        INC     $E2             ; INDEX UP ONE
        LDA     $E2             ; LAST CHARACTER?
        CMP     #$1A
        BEQ     DEBO            ; YES, GO READOUT
        LDA     CHARS,X         ; GET CODE CHARACTER
        STA     $DF             ; TEMPORARY STORE
BITS:   ASL     $DF             ; SHIFT
        BEQ     CHAR            ; EMPTY, GET NEXT CHAR.
        BCS     DASH            ; IF CARRY SET, SEND DASH
        LDX     #$01            ; ..ELSE SEND DOT
        JSR     MARK
SPAC:   LDX     #$01            ; THEN SPACE
        JSR     SPACE
        CLC
        BCC     BITS            ; UNCOND. JUMP
DASH:   LDX     #$03            ; (DASH LENGTH)
        JSR     MARK            ; SEND A DASH
        CLC
        BCC     SPAC            ; UNCOND. JUMP
DEBO:   JSR     INIT1           ; DEBOUNCE KEY..
        JSR     DISP
        BNE     DEBO            ; WAIT FOR KEY RELEASE
WAIT:   JSR     DISP
        BEQ     WAIT            ; WAIT FOR KEY DOWN
        CLC
        LDA     $E4             ; UPDATE POINTER TO
        ADC     #$05            ; POINT AT NEXT GROUP..
        STA     $E4
        LDY     #$04            ; ..LOAD WINDOWS 00E8-
WIND:   LDA     ($E4),Y         ; 00EC WITH CONVERSIONS
        STA     $E8,Y           ; FOR DISPLAY..
        DEY
        BPL     WIND
        DEC     $E3             ; LAST GROUP?
        BNE     DEBO            ; NO, GET ANOTHER
        LDA     #$54            ; REINITILIZE POINTER
        STA     $E4             ; TO RUN THRU GROUPS AGAIN
        LDA     #$05
        STA     $E3
        BNE     DEBO            ; UNCOND. JUMP

;      ***** MARK SUBROUTINE ****

MARK:   STX     $DD             ; TEMP. STORE
TIMM:   LDA     $E6             ; SPEED BYTE
        STA     $1747           ; START TIMER
        LDA     #$80            ; PBD TO OUTPUT
        STA     PBDD
TOGG:   INC     PBD             ; TOGGLE PB7
        LDX     $E7             ; DETERMINE FREQ.
FREQ:   DEX
        BNE     FREQ
        BIT     $1747           ; TIME UP?
        BPL     TOGG            ; NO
        DEC     $DD             ; DETERMINE MARK LENGTH
        BNE     TIMM
        RTS

;        ***** SPACE SUBROUTINE *****

SPACE:  STX     $DD             ; TEMP. STORE
TIMS:   LDA     $E6             ; SPEED BYTE
        STA     $1747           ; START TIMER
HOLD:   BIT     $1747           ; DONE?
        BPL     HOLD            ; NO
        DEC     $DD             ; FULL TIME UP?
        BNE     TIMS            ; NO
        RTS

;          ***** DISPLAY ON LEDs SUBROUTINE *******

DISP:   LDA     #$7F            ; CHANGE SEGMENTS..
        STA     PADD            ; TO OUTPUTS
        LDY     #$0             ; INIT. RECALL INDEX
        LDX     #$9             ; INIT. DIGIT NUMBER
SIX:    LDA     $E8,Y           ; GET CHARACTER
        STY     $FC             ; SAVE Y
        JSR     $1F4E           ; DISPLAY CHARACTER
        INY                     ; SET UP FOR NEXT OAR.
        CPY     #$06            ; 6 CHAR. DISPLAYED?
        BCC     SIX             ; NO
        JSR     $1F3D           ; KEY DOWN?
        RTS                     ; EXIT

;          ***** RANDOM NUMBER SUBROUTINE ******

RAND:   SEC                     ; FROM J. BUTTERFIELD
        CLD                     ; KIM USER NOTES
        LDA     $D1             ; VOL. 1, *1
        ADC     $D4
        ADC     $D5
        STA     $D0
        LDX     #$04
ROLL:   LDA     $D0,X
        STA     $D1,X
        DEX
        BPL     ROLL
        RTS

;           ***** INITIALIZATION VALUES *******
VALUES:

	.BYTE   $00,$05,$36,$03,$33,$64,$C0,$C0,$C0,$C0,$C0,$00

;           ***** TABLE OF CODE CHARACTERS *******

CHARS:
        .BYTE   $60,$88,$A8,$90,$40
        .BYTE   $28,$D0,$08,$20,$78,$B0,$48,$E0,$A0,$F0,$68,$D8,$50,$10,$C0,$30
        .BYTE   $18,$70,$98,$B8,$C8,$FC,$7C,$3C,$1C,$0C,$04,$84,$C4,$E4,$F4,$56
        .BYTE   $CE,$32,$8C

;           ***** TABLE OF DISPLAY CONVERSIONS ******

CONVRS:
        .BYTE  $F7,$FC,$B9,$DE,$F9,$F1,$BD,$F6,$84,$9E,$F0,$B8,$B7
        .BYTE  $D4,$DC,$F3,$E7,$D0,$ED,$F8,$BE,$EA,$9C,$94,$EE,$C9,$BF,$86,$DB
        .BYTE  $CF,$E6,$ED,$FD,$87,$FF,$EF,$90,$84,$D3,$C8

; *** STORAGE OF CHARACTERS SENT: $033B - onward

STORE:
	.BYTE $00
